bento.define("game/entities/player",["bento","bento/eventsystem","bento/utils","globals","events","bento/components/eventlistener","game/effects/animation","bento/components/sprite","bento/math/vector2","modules/playerdata","game/animators/jump","game/components/alarm","game/effects/speechbubble","bento/tween","game/components/tileimpacter","game/components/shield","game/components/actorsprite"],function(e,t,n,o,a,i,r,l,c,s,m,f,p,u,v,d,g){"use strict";return function(l){var h=l.actor,y=l.map,w=!1,E=!1,b=[],A={x:1,y:1},C=new i({eventName:a.Elevator.START,onEvent:function(e){w=!0,h.collider.setActive(!1)}}),P=new i({eventName:a.Elevator.DROP_PLAYER,onEvent:function(e){w=!1,h.collider.setActive(!0)}}),T=function(t,n){if(-1!==y.getHeightAt(t,n))return y.getHeightAt(t,n);var o=e.objects.getByFamily("elevator");for(let e=0;e<o.length;e++){let a=o[e].mapPosition;if(a.x===t&&a.y===n)return a.z}return-999},N=new g({imageName:"players/"+s.load("SELECTED_SKIN"),originRelative:new c(.5,1),frameWidth:48,frameHeight:48,backFacingOffset:16,animations:{idle:{speed:.18,frames:[0,1,2,3,4,5,2,6],loop:!0,hasBackFacing:!0},jump:{speed:.24,frames:[10,11,12,13],loop:!1,hasBackFacing:!0},land:{speed:.24,frames:[10,8,9,8,7],loop:!1,hasBackFacing:!0},angry:{speed:.24,frames:[14,15],loop:!0,hasBackFacing:!1}}});N.faceFront(),N.setAnimation("idle");var L=function(e,t){h.scale.x=A.x||1,1===A.y?N.faceFront():N.faceBack(),N.setAnimation(e,t)},S=new m({map:y,gravity:.035});S.on("begin",function(t){L("jump"),0===t.diff.col&&0===t.diff.row?e.audio.playSound("sfx_wrong"):e.audio.playSound("player/sfx_qbert_jump");var n=Math.floor(t.duration);h.attach(new f({name:"landAlarm",duration:n-4,onComplete:function(){L("land",function(){L("idle")})}}))}),S.on("finish",function(n){if(t.fire("taptics",o.Taptics.LIGHT),!E){l.map.getTile(n.to.col,n.to.row)&&(3===b.length&&b.shift(),b.push({col:n.to.col,row:n.to.row}))}e.objects.attach(new r({effect:"land_effect",position:h.position.clone()}))});var _=new i({name:"levelCompleteListener",eventName:a.Level.COMPLETE,ignorePause:!1,onEvent:function(e){var t=y.getTile(h.mapPosition.x,h.mapPosition.y);E=!1;var n=function(){new u({from:0,to:1,in:16,delay:24,ease:"easeInOutQuad",onStart:function(){N.faceFront(),N.setAnimation("jump")},onUpdate:function(e,t){var n=e*(1-e)*4;h.transform.y=-24*n},onComplete:function(){N.faceFront(),N.setAnimation("land",function(){N.setAnimation("idle")}),t.top.playImpact(),n()}})};n()}}),I=new i({name:"playerDeathListener",eventName:a.Player.DEATH,ignorePause:!1,onEvent:function(t){E=!0,e.audio.playSound("player/sfx_qbert_hit");var o=new p({offset:new c(8,-36),player:h}),a=h.getComponent("landAlarm");a?a.onComplete=function(){L("land",function(){E?N.setAnimation("angry"):L("idle")})}:N.setAnimation("angry"),n.timeout(45,function(){if(E){var t="player/sfx_qbert_speech_"+n.random.pick(["01","02"]);e.audio.playSound(t),e.objects.attach(o)}})}}),D=new i({eventName:a.Player.DESPAWN,onEvent:function(e){n.removeFamily("speech")}}),k=new i({eventName:a.Level.REVIVE,onEvent:function(e){E=!1}}),F=new i({eventName:a.Player.RESPAWN,onEvent:function(e){N.setAnimation("idle");var t=n.currentLevel.getStartPosition();for(let e=b.length-1;e>=0;e--){let n=b[e];if(l.map.getTile(n.col,n.row).getComponent("safety").isSafe()){t=n;break}}var o=T(t.col,t.row);h.mapPosition.set(t.col,t.row,o)}}),x=new i({eventName:a.Player.SKIN_CHANGE,ignorePause:!0,onEvent:function(e){h.remove(N),e.key,N.setImageName("players/"+s.load("SELECTED_SKIN")),h.attach(N),h.moveComponentTo(N,0),L("idle")}});h.name="player",h.addToFamily("player"),h.attach(N),h.attach(_),h.attach(I),h.attach(D),h.attach(F),h.attach(k),h.attach(C),h.attach(P),h.attach(x),h.movable.setAnimator(S),h.attach(new v),h.transform.y=-4,h.attach(new i({eventName:a.Shields.ACTIVATED,onEvent:function(e){h.attach(new d({isValidEnemyCollision:M}))}})),h.attach(new i({eventName:a.Shields.DEACTIVATED,onEvent:function(e){h.getComponent("shield",function(e){h.remove(e)})}}));h.dispatcher.on("postMove",function(e){e.player=h,t.fire(a.Player.POST_MOVE,e)});var M=function(e){var t=h.movable.movement.diff,n=e.movable.movement.diff,o=h.movable.isMoving&&e.movable.isMoving;if(e.getComponent("freeze")&&(o=!1),o){var a=n.col+t.col,i=n.row+t.row;if(Math.abs(a)+Math.abs(i)!==0)return!1}return!0};h.collider.addTag(o.CollisionTags.PLAYER),h.collider.onCollision(o.CollisionTags.ENEMY,function(e){var n=e.entity;M(n)&&t.fire(a.Player.KILL,{enemy:n})}),h.collider.onCollision(o.CollisionTags.KILLABLE,function(n){var o=n.entity;o.dispatcher.fire("killed"),e.objects.remove(o),o.getComponent("enemy",function(e){e.showDisappearEffect(),t.fire(a.Enemy.KILLED,{enemy:o,cause:"player"})})}),h.collider.onCollision(o.CollisionTags.PICK_UP,function(e){e.entity.getComponent("pickUp",function(e){e.pickUp()})});var j=function(e,t){t<0||e>0?A.x=1:(t>0||e<0)&&(A.x=-1),t>0||e>0?A.y=1:(t<0||e<0)&&(A.y=-1)};return h.movable.addModifier(function(t){if(w)return!0;j(t.to.col-t.from.col,t.to.row-t.from.row);var n=T(t.to.col,t.to.row);if(-999===n||n-t.from.height>1)return t.to.col=t.from.col,t.to.row=t.from.row,t.to.height=t.from.height,void e.objects.attach(new r({position:h.position.add(new c(0,-16)),effect:"effect_wrong"}));t.to.height=n}),b.push({col:h.mapPosition.col,row:h.mapPosition.row}),n.append(h,{isAlive:function(){return!E},isDead:function(){return E},setMoveDirection:j}),h}});